<id>
HTML for YaBB 1
</id>

<version>
1.0
</version>

<mod info>
Behold the glory that is HTML.
For YaBB!

Simply put: This mod allows a user to post specified HTML tags in there posts.

Installation:
Add the HTML.pl file to the Sources directory.
Add the HTMLtags.txt file to teh Variables directory.
Install the HTML_for_YaBB.mod with BoardMod.

Enabling HTML:
By default, HTML is disabled.
To enable HTML, there is a checkbox directly under the enable UBBC checkbox in the Forum Preferences and Settings.

To Post with HTML:
Simply use the allowed HTML in your message and post it. If there is an error, you will automatically be directed to the Preview page and informed of the error.

Specifying HTML:
Obviously you don't want anyone to screw up the boards so you must specify which HTML tags are allowed.
To specify HTML tags, there is a link under the Enable HTML checkbox in the Forum Preferences and Settings.
By default, there are already three tags specified. Bold, Italics, and Underline. (<b>, <i>, <u>)
You can add up to two tags at a time. If a tag requires a closing tag (</b>, </i>, </u>), check the appropriate checkbox.
To delete already saved tags, check the appropriate checkbox.

NOTES:
An error occurs when quotation marks are used (as is common in HTML) and the Auto-link URLs feature, so while HTML is enabled, Auto-link URLs is disabled.
</mod info>

<author>
BRO_co03
</author>

<homepage>
http://broco03.no-ip.com
</homepage>

<edit file>
Sources/AdminEdit.pl
</edit file>

<search for>
	if ($enable_ubbc) { $ubbcchecked = ' checked'; }
</search for>

<add after>
	if ($enable_html) { $htmlchecked = ' checked'; }

</add after>

<search for>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'378'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="enable_ubbc"$ubbcchecked></td>
</search for>

<add after>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$htmltxt{'01'}</font><br><font size=1><a href="$scripturl?action=edithtml">$htmltxt{'02'}</a></font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="enable_html" value="1" $htmlchecked></td>
</add after>

<search for>
	&ToHTML($maintenancetext);
</search for>

<add after>
	$enable_html = $FORM{'enable_html'} || 0;
</add after>

<search for>
\$enable_ubbc = $enable_ubbc;				# Set to 1 if you want to enable UBBC (Uniform Bulletin Board Code)
</search for>

<add after>
\$enable_html = $enable_html;				# Set to 1 if you want to enable HTML (HyperText Markup Language)
</add after>

<edit file>
Sources/SubList.pl
</edit file>

<search for>
'admin',"Admin.pl&Admin",
</search for>

<add after>
'edithtml',"HTML.pl&EditHTML",
'edithtml2',"HTML.pl&EditHTML2",
</add after>

<edit file>
english.lng
</edit file>

<search for>
$txt{'800'} = "Other";

</search for>

<add after>
### HTML for YaBB ###

$htmltxt{'01'} = "Enable HTML?";
$htmltxt{'02'} = "Click here to set the HTML tags you want to use.";
$htmltxt{'03'} = "Edit HTML Settings";
$htmltxt{'04'} = "Enter the tags you want to allow on the first column and the attributes of each that you want to allow on the second. You do not need to input the &lt;&gt;, just the tag name (example: a). Separate the attributes with a vertical bar (example: href|target). If a tag has no attributes, leave it blank or insert a tilde (~).<br><br>If a closing tag exists (example: /a), then check the first checkbox.<br>To delete a tag or its attribute, check the last checkbox.";
$htmltxt{'05'} = "The HTML list no longer exists. You must reenter the data below.";
$htmltxt{'06'} = "Tag";
$htmltxt{'07'} = "Attribute";
$htmltxt{'08'} = "Close?";
$htmltxt{'09'} = "Delete?";
$htmltxt{'10'} = "You do not have any tags specified.";
$htmltxt{'11'} = "HTMLtags.txt file does not exist. Please inform the administrator.";
# The following are error messages that occur when a user has inputed bad HTML code.
$htmltxt{'12'} = "The closing tags must be in reverse order.";
$htmltxt{'13'} = "You have additional closing tags. Please remove them.";
$htmltxt{'14a'} = "The";
$htmltxt{'14b'} = "tag is not allowed.";
$htmltxt{'15'} = "You left some tags open. Please close them.";
$htmltxt{'16'} = "You have used some illegal tags. Please fix them in order to post or see the preview.";
$htmltxt{'17'} = "There is a quotation error in one of your tags. Please fix them in order to post or see the preview.";
$htmltxt{'18a'} = "The";
$htmltxt{'18b'} = "in";
$htmltxt{'18c'} = "is not allowed.";
$htmltxt{'19'} = "You forgot a quotation mark in";

</add after>

<edit file>
Settings.pl
</edit file>

<search for>
$enable_ubbc = 1;                                                     # Set to 1 if you want to enable UBBC (Uniform Bulletin Board Code)
</search for>

<add after>
$enable_html = 0;                                                     # Set to 1 if you want to enable HTML (HyperText Markup Language)
</add after>

<edit file>
Sources/Display.pl
</edit file>

<search for>
		# Print the post and user info for the poster.
		$yymain .= qq~
</search for>

<add before>
		if ($enable_html == 1) { &FromHTML($message); }
</add before>

<edit file>
Sources/Post.pl
</edit file>

<search for>
	if( $FORM{'preview'} ) { &Preview; }
</search for>

<add before>
	if ($enable_html == 1) {
		require "$sourcedir/HTML.pl";
		&DoHTML;
	}
</add before>

<search for>
	$yymain .= qq~
<script language="JavaScript1.2" type="text/javascript" src="$ubbcjspath"></script>
<script language="JavaScript1.2" type="text/javascript">
</search for>

<add before>
	if ($enable_html == 1) {
		$message = $preview_message;
		if ($error_exists == 1 || $quote_error_exists == 1) {
			$yymain .= qq~
<table border=0 width="90%" cellspacing=1 cellpadding="3" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=1>$errors</font></td>
  </tr>
</table>
			~;
		}
	}
</add before>

<edit file>
Sources/YaBBC.pl
</edit file>

<search for>
	if( $autolinkurls ) {
</search for>

<replace>
	if( $autolinkurls && $enable_html == 0 ) {
</replace>